#include <sys/types.h>
#define _SIZE_T
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "pmhead.h"
/***************************************************************
 *  GLOBAL DATA used pm                 <pmdata.c>
 **************************************************************/

#define  GD_DATA

char *rd_data = 0;
char *wr_data = 0;
char *prm_buf = 0;

char home_dir[128] = {0,};
char cur_dir[128] = {0,};
unsigned int alloc_cnt_wr = 0;
unsigned int alloc_cnt_rd = 0;
unsigned int alloc_cnt_prm = 0;

#include  "pmhead.h"

extern errno;

/*** prototypes ***/
char  *get_command();
void  save_log_data();

/*******************************************************************
 *   PM function handler
 *                                       '93.1.12 by R.K
 ******************************************************************/
char *pm(sn)
char sn[];
	{
	register i,j,k;
	char *c, *prmp;
	char *r;
	char wkbuf[128];
	char *buf;
  	static char hdir[128];
	int ret;
  	static FILE *fp;
	static int initflag;
  	/*** move current directory ***/
	getcwd(hdir,sizeof(hdir));
	if(hdir[strlen(hdir)-1] == '\n')
      		hdir[strlen(hdir)-1] = NULL;
	strcpy(home_dir,hdir);
	sprintf(cur_dir,"%s/quixote_pm",home_dir);
	/*** change current dir ***/
  	if((ret = opr_cd("quixote_pm")) < 0)
		{
    		opr_cmnd("mkdir quixote_pm");
    		opr_cd("quixote_pm");
  		}

        if(initflag==0){
  	/*** open translate log file ***/
  	fp = fopen("pm_log","w");
  	fclose(fp);

        allocdata();

	initflag=1;
      }
	buf = rd_data;
	/*** command handling *****************************************/
		for(i = 0;sn[i]!='\0'; i++)
			{
			 buf[i]=sn[i];
			if( buf[i]== '\n' )
				break;
			if( i == ((BUF_MAX * alloc_cnt_rd)-1) )
				{
				alloc_cnt_rd++;
				buf = realloc(buf,(BUF_MAX*alloc_cnt_rd));
				if(buf == NULL)
				    {
				    printf("pm_server: memory reallocation\n");
				    exit(1);
				    }
				rd_data = buf;

				alloc_cnt_prm++;
				prm_buf = realloc(prm_buf,(BUF_MAX * alloc_cnt_prm));
				if( prm_buf == NULL )
				    {
				    printf("pm_server: memory reallocation\n");
				    exit(1);
				    }
				}
			}
		buf[i] = '\0';

		/*** remove ' ' ***/
		for(j=0,k=0;j<i;j++)
		    {
		    if(buf[j] == ' ') continue;
		    if(buf[j] == '\'')
			{
			buf[k++] = buf[j];
			for(j++;j<i;j++)
				{
				if(buf[j] != '\'') buf[k++] = buf[j];
				else
					{
					buf[k++] = buf[j];
					break;
					}
				}
			if(j<i) continue;
			else    break;
			}
		    if(buf[j] == '\"')
			{
			buf[k++] = buf[j];
			for(j++;j<i;j++)
				{
				if(buf[j] != '\"') buf[k++] = buf[j];
				else
					{
					buf[k++] = buf[j];
					break;
					}
				}
			if(j<i) continue;
			else    break;
			}
		    buf[k++] = buf[j];
		    }
                buf[k]='\0';
		/*** save rx data log in "pm_log" file ***/
		save_log_data(1,buf);
    
		/*** command get ***/
		c = get_command(buf);
                buf=opr_search_comma(buf+1,0);
		/*** commands ***/
		if(!strcmp(c,"end_PM"))
			{ /*** end_PM ***/
			end_PM(buf);
			}
		else if(!strcmp(c,"reset"))
			{ /*** reset ***/
			reset(buf);
			}
		else if(!strcmp(c,"create_PM"))
			{ /*** create_PM ***/
			create_PM(buf);
			}
		else if(!strcmp(c,"ls"))
			{ /*** ls ***/
			ls_c(buf);
			}
		else if(!strcmp(c,"ls_l"))
			{ /*** ls_l ***/
			prmp = (buf);
			ls_l_c(prmp);
			}
		else if(!strcmp(c,"mkdir"))
			{ /*** mkdir ***/
			prmp = (buf);
			mkdir_c(prmp);
			}
		else if(!strcmp(c,"rmdir"))
			{ /*** rmdir ***/
			prmp = (buf);
			rmdir_c(prmp);
			}
		else if(!strcmp(c,"rm"))
			{ /*** rm ***/
			prmp = (buf);
			rm_c(prmp);
			}
		else if(!strcmp(c,"rm_all"))
			{ /*** rm_all ***/
			prmp = (buf);
			rm_all_c(prmp);
			}
		else if(!strcmp(c,"check"))
			{ /*** check ***/
			prmp = (buf);
			check_c(prmp);
			}
		else if(!strcmp(c,"purge"))
			{ /*** purge ***/
			prmp = (buf);
			purge_c(prmp);
			}
		else if(!strcmp(c,"get_text_DB"))
			{ /*** get_text_DB ***/
			prmp = (buf);
			get_text_DB(prmp);
			}
		else if(!strcmp(c,"get_DB"))
			{ /*** get_DB ***/
			prmp = (buf);
			get_DB(prmp);
			}
		else if(!strcmp(c,"get_last_version"))
			{ /*** get_last_version ***/
			prmp = (buf);
			get_last_version(prmp);
			}
		else if(!strcmp(c,"put_DB_with_qxt"))
			{ /*** put_DB_with_qxt ***/
			prmp = (buf);
			put_DB_with_qxt(prmp);
			}
		else if(!strcmp(c,"put_DB"))
			{ /*** put_DB ***/
			prmp = (buf);
			put_DB(prmp);
			}
		else if(!strcmp(c,"update_DB"))
			{ /*** update_DB ***/
			prmp = (buf);
			update_DB(prmp);
			}
		else
			{
			sprintf(wr_data,
				"{result,{abnormal,\"command not found\"}}",
				c);
/*			write(sn,wr_data,strlen(wr_data)); */
			}

		/*** save tx data in "pm_log" file ***/
		save_log_data(0,wr_data);
	        opr_cd(home_dir);
                return wr_data;
/*		}

*/	/*** save tx data in "pm_log" file ***/
/*	save_log_data(0,wr_data);
	strncpy(buf,"",BUF_MAX);
	strncpy(wr_data,"",BUF_MAX);
	strncpy(prm_buf,"",BUF_MAX);
*/
	}

static char *get_command(b)
char *b;
	{
	static char cb[128];
	register i,j;

	if(b[0] == '{')
		{
		for(i=1,j=0;(b[i] != ',') && (b[i] != '}');i++)
		   if(b[i]!='\'') 	
                      cb[j++] = b[i];
		cb[j] = 0;
		}
	else
		{
		for(i=0;(b[i] != '(') && (b[i] != 0) && (b[i] != '\n');i++)
			cb[i] = b[i];
		cb[i] = 0;
		}
	b=b+i;
	return(cb);
	}

/*******************************************************************
 * save_log_data()
 *
 * <INPUT>
 *      int   prompt   : prompt sel flag
 *                          0 = TX DATA
 *                         !0 = RX DATA
 *
 *      char  *databuf : command data save buffer pointer
 *
 * <OUTPUT>
 *      none
 * 
 ******************************************************************/

void save_log_data(prompt,databuf)
int   prompt;
char  *databuf;
	{
	char  wbuf[40960];
	FILE *fp;
	int  i;
	time_t time(),timer;

	/*** save data to buffer ***/
	if( prompt == 0 )
		strcpy(wbuf,"[ TX DATA >> ] : ");
	else
		strcpy(wbuf,"[ RX DATA << ] : ");

	timer = time(0);
	strcat(wbuf,ctime(&timer));
	if(wbuf[strlen(wbuf)-1] == '\n' )
		wbuf[strlen(wbuf)-1] = NULL;

	strcat(wbuf," : ");

/*	strncat(wbuf,databuf,25); */
	strncat(wbuf,databuf,40960); 
	if(wbuf[strlen(wbuf)-1] == '\n' )
		wbuf[strlen(wbuf)-1] = NULL;

	/*** save data in "pm_log" file ***/ 
	fp = fopen("pm_log","a");
	opr_write(fp,wbuf,strlen(wbuf));
	fputc('\n',fp);
	fclose(fp);
	}


allocdata()
{
 
      			if( (rd_data = calloc(BUF_MAX,1)) == NULL )
				{
				printf("pm_server: memory allocation(used RX data)\n");
				exit(1);
      				}
      			alloc_cnt_rd = 1;

      			if( (wr_data = calloc(BUF_MAX,1)) == NULL )
				{
				printf("pm_server: memory allocation(used TX data)\n");
				exit(1);
      				}
      			alloc_cnt_wr = 1;

      			if( (prm_buf = calloc(BUF_MAX,1)) == NULL )
				{
				printf("pm_server: memory allocation(used RX prm)\n");
				exit(1);
      				}
      			alloc_cnt_prm = 1;
}  
/***** <<< END OF pm.c >>>******/




























